// ;|
// Author:          Roy Klein Gebbinck (www.b-k-g.nl)
// New version for: https://forum.bricsys.com/discussion/32898/edit-of-dimension
// Original for:    https://forum.bricsys.com/discussion/18333/how-do-change-edit-text-box-size
//
// This is a 'mixed mode file': it contains DCL and LSP code.
// See: https://www.theswamp.org/index.php?topic=52289.msg572643#msg572643

AltEdit : dialog {
  fixed_width = false;
  initial_focus = "input";
  label = "AltEdit";
  : edit_box {
    key = "input";
    allow_accept = true;
    fixed_width_font = true;
    width = 60;
  }
  ok_cancel;
}
/* |;

(defun c:AltEdit ( / dcl doc enm fnm new old ret ss)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-endundomark doc)
  (vla-startundomark doc)
  (if
    (and
      (or
        (and
          (setq ss (cadr (ssgetfirst)))
          (= 1 (sslength ss))
          (setq enm (ssname ss 0))
        )
        (setq enm (car (entsel)))
      )
      (setq obj (vlax-ename->vla-object enm))
      (or
        (vlax-property-available-p obj 'textstring)   ; For texts and mtexts.
        (vlax-property-available-p obj 'textoverride) ; For dimensions.
        (prompt "\nError: entity not supported ")
      )
      (or
        (and
          (setq fnm
            (vl-some
              '(lambda (str)
                (if (wcmatch (strcase str) "*ALTEDIT*") str) ; This file's name must match "*ALTEDIT*".
              )
              (reverse (vl-list-loaded-lisp))
            )
          )
          (< 0 (setq dcl (load_dialog fnm)))
        )
        (prompt "\nError: dcl dialog not found ")
      )
    )
    (progn
      (setq old
        (vlax-get
          obj
          (if (vlax-property-available-p obj 'textstring) 'textstring 'textoverride)
        )
      )
      (if (not *AltEdit_diaPos*) (setq *AltEdit_diaPos* '(-1 -1)))
      (new_dialog "AltEdit" dcl "" *AltEdit_diaPos*)
      (set_tile "input" old)
      (action_tile "input"  "(setq new $value)")
      (action_tile "accept" "(setq *AltEdit_diaPos* (done_dialog 1))")
      (action_tile "cancel" "(setq *AltEdit_diaPos* (done_dialog 0))")
      (setq ret (start_dialog))
      (unload_dialog dcl)
      (if
        (and
          (= 1 ret)
          new
          (/= old new)
        )
        (vlax-put
          obj
          (if (vlax-property-available-p obj 'textstring) 'textstring 'textoverride)
          new
        )
      )
    )
  )
  (vla-endundomark doc)
  (princ)
)
